<?php

/**
 * Implementation of hook_views_data().
 *
 * Exposes all fields to the views system.
 */
function flashvideo_views_views_data() {
  $data = array();
  
  $data['flashvideo']['table']['group']  = t('FlashVideo');

  $data['flashvideo']['table']['join']['node'] = array(
     'left_table' => 'files',
     'left_field' => 'fid',
     'field' => 'fid',
     'extra' => '(files.filemime <> image/jpeg) AND (files.filemime <> image/png) AND (files.filemime <> image/gif)'
  );  
  
  $data['flashvideo']['nid'] = array(
    'title' => t('FlashVideo Video'),
    'help' => t('Add a flashvideo thumbnail or video as a field to this view.'), 
    'field' => array(
      'handler' => 'flashvideo_views_field_video',
      'click sortable' => FALSE,
    )  
  );
  
  return $data;
}

/**
 * A handler to provide proper displays for dates.
 */
class flashvideo_views_field_video extends views_handler_field {
  function option_definition() {
    $options = parent::option_definition();   
    $options['flashvideo_field'] = array('default' => 'thumbnail');
    return $options;
  }

  function options_form(&$form, &$form_state) {
    parent::options_form($form, $form_state);
    $form['flashvideo_field'] = array(
      '#type' => 'select',
      '#title' => t('FlashVideo Field'),
      '#options' => array(
        'thumbnail' => 'Thumbnail',
        'video' => 'Video'
      ),
      '#default_value' => isset($this->options['flashvideo_field']) ? $this->options['flashvideo_field'] : 'thumbanil',
    );
  }

  function render($values) {
    $node = node_load($values->nid);
    switch ($this->options['flashvideo_field']) {
      case 'thumbanail':
        return flashvideo_get_thumbnail($node);
      case 'video':
        return flashvideo_get_video($node);
      default:
        return flashvideo_get_thumbnail($node);
    }
  }  
}
?>